/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <device.h>

/*DECLARATION IMPORTANTE : N?cessaire pour charger la biblioth?que de symbole pour l'affichage type Bargraphe */
extern const uint8 LCD_Char_1_customFonts[];


void main()
{ 	
 	
	/*Declaration des variables utilis?es*/
	unsigned int resultat_conv;
	
	/* Initialisation de l'affichage */
	LCD_Char_1_Start();
	//chargement de la table de caract?re pour l'affichage bargraphe
    LCD_Char_1_LoadCustomFonts(LCD_Char_1_customFonts);
	
	/*Initialisation du CAN */
	ADC_SAR_1_Start();
		
    /* CYGlobalIntEnable; */ /* Uncomment this line to enable global interrupts. */
    //bon ben pas d'interruption ici ...
	while(1)
    {
        /* Ici le d?but de la boucle infinie while(1){.....}*/
		
		/*Lancement de la conversion analogique / num?rique */
		ADC_SAR_1_StartConvert();
		
		/*Boucle d'attente de fin de conversion */
		do {;}
		while(ADC_SAR_1_IsEndConversion(ADC_SAR_1_RETURN_STATUS)==0);
		
		/*Recup?ration r?sultat de conversion */
		resultat_conv=ADC_SAR_1_GetResult16();//R?cup?ration de la donn?e au format 16bits
				
								
		/*Affichage sous forme de bargraphe et valeur de la conversion*/
		//Afficher valeur du r?sultat de conversion
		LCD_Char_1_Position(1, 0);
		LCD_Char_1_PrintString("Valeur conv=    ");
		LCD_Char_1_Position(1, 13);
		LCD_Char_1_PrintNumber(resultat_conv);
		
		//Afficher le bargraphe
		LCD_Char_1_DrawHorizontalBG(0,0,16, resultat_conv>>2);
				//l'op?ration de d?calage >>2 ci-dessus permet une division par 4 ce qui am?ne une
				//valeur max de 63 et donc inf?rieure ? 80, qui est la valeur max d'affichage sur
				//le bargraphe (16 caract?res * 5 pixels/colonne ==>80 colonnes au total)
		
		
		
		
		/*Ici une temporisation de 50ms avant la reprise ...*/
		CyDelay(50);
		
	}
}
		


/* [] END OF FILE */
