/* ========================================
 *Laurent Proust : Vu-m?tre LCD
 * ========================================
*/
#include <device.h>

/*DECLARATION IMPORTANTE : N?cessaire pour charger la biblioth?que de symbole pour l'affichage type Bargraphe */
extern const uint8 LCD_Char_1_customFonts[];


void main()
{ 	
  	/*Declaration des variables utilis?es*/
	unsigned int resultat_conv;
	unsigned char tableau[20];
	unsigned char plus_grand=0,i=0;
	/* Initialisation de l'amplificateur */
	PGA_1_Start();
	/* Initialisation de l'affichage */
	LCD_Char_1_Start();
	//chargement de la table de caract?re pour l'affichage bargraphe
    LCD_Char_1_LoadCustomFonts(LCD_Char_1_customFonts);
	/*Initialisation du CAN */
	ADC_SAR_1_Start();
	/* CYGlobalIntEnable; */ /* Uncomment this line to enable global interrupts. */
    while(1)
    {
        /* Ici le d?but de la boucle infinie while(1){.....}*/
		/*Lancement de la conversion analogique / num?rique */
		ADC_SAR_1_StartConvert();
		/*Boucle d'attente de fin de conversion */
		do {;}
		while(ADC_SAR_1_IsEndConversion(ADC_SAR_1_RETURN_STATUS)==0);//Recup?ration r?sultat de conversion
		resultat_conv=abs(ADC_SAR_1_GetResult16());/* R?cup?ration de la donn?e au format 16bits
		pour ?viter les probl?mes li?s au signe */
				
			/*detecter la plus grande valeur de conversion sur les 20 derniers ?chantillons*/
			for (i=0;i<=19;i++)
			{tableau[i]=tableau[i+1];}//decalage des echantillons
			tableau[19]=resultat_conv;//Affectation du dernier echantillon ? tableau[19] 
			plus_grand=0;
			for (i=0;i<=19;i++)
			{	if (plus_grand<tableau[i])
				{plus_grand=tableau[i];	}
			}
			/* fin de calcul */
	
		/*Affichage sous forme de bargraphe et valeur de la moyenne*/
		//Afficher valeur du r?sultat de conversion
		LCD_Char_1_Position(1, 0);//positionner le curseur en position ligne=1 et colonne = 0
		LCD_Char_1_PrintString("Valeur conv=    ");//Placer du texte 
		LCD_Char_1_Position(1, 13);
		LCD_Char_1_PrintNumber(plus_grand);
		
		//Afficher le bargraphe
		LCD_Char_1_DrawHorizontalBG(0,0,16, plus_grand>>2);
				//l'op?ration de d?calage >>2 ci-dessus permet une division par 4 ce qui am?ne une
				//valeur max de 63 et donc inf?rieure ? 80, qui est la valeur max d'affichage sur
				//le bargraphe (16 caract?res * 5 pixels/colonne ==>80 colonnes au total)
		}
}
		


/* [] END OF FILE */
