/*******************************************************************************
* File Name: SWITCH1.h  
* Version 1.20
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2009, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_SWITCH1_H) /* Pins SWITCH1_H */
#define CY_PINS_SWITCH1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "SWITCH1_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    SWITCH1_Write(uint8 value);
void    SWITCH1_SetDriveMode(uint8 mode);
uint8   SWITCH1_ReadDataReg(void);
uint8   SWITCH1_Read(void);
uint8   SWITCH1_ClearInterrupt(void);

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define SWITCH1_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define SWITCH1_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define SWITCH1_DM_RES_UP          PIN_DM_RES_UP
#define SWITCH1_DM_RES_DWN         PIN_DM_RES_DWN
#define SWITCH1_DM_OD_LO           PIN_DM_OD_LO
#define SWITCH1_DM_OD_HI           PIN_DM_OD_HI
#define SWITCH1_DM_STRONG          PIN_DM_STRONG
#define SWITCH1_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define SWITCH1_MASK               SWITCH1__MASK
#define SWITCH1_SHIFT              SWITCH1__SHIFT
#define SWITCH1_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define SWITCH1_PS                     (* (reg8 *) SWITCH1__PS)
/* Data Register */
#define SWITCH1_DR                     (* (reg8 *) SWITCH1__DR)
/* Port Number */
#define SWITCH1_PRT_NUM                (* (reg8 *) SWITCH1__PRT) 
/* Connect to Analog Globals */                                                  
#define SWITCH1_AG                     (* (reg8 *) SWITCH1__AG)                       
/* Analog MUX bux enable */
#define SWITCH1_AMUX                   (* (reg8 *) SWITCH1__AMUX) 
/* Bidirectional Enable */                                                        
#define SWITCH1_BIE                    (* (reg8 *) SWITCH1__BIE)
/* Bit-mask for Aliased Register Access */
#define SWITCH1_BIT_MASK               (* (reg8 *) SWITCH1__BIT_MASK)
/* Bypass Enable */
#define SWITCH1_BYP                    (* (reg8 *) SWITCH1__BYP)
/* Port wide control signals */                                                   
#define SWITCH1_CTL                    (* (reg8 *) SWITCH1__CTL)
/* Drive Modes */
#define SWITCH1_DM0                    (* (reg8 *) SWITCH1__DM0) 
#define SWITCH1_DM1                    (* (reg8 *) SWITCH1__DM1)
#define SWITCH1_DM2                    (* (reg8 *) SWITCH1__DM2) 
/* Input Buffer Disable Override */
#define SWITCH1_INP_DIS                (* (reg8 *) SWITCH1__INP_DIS)
/* LCD Common or Segment Drive */
#define SWITCH1_LCD_COM_SEG            (* (reg8 *) SWITCH1__LCD_COM_SEG)
/* Enable Segment LCD */
#define SWITCH1_LCD_EN                 (* (reg8 *) SWITCH1__LCD_EN)
/* Slew Rate Control */
#define SWITCH1_SLW                    (* (reg8 *) SWITCH1__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define SWITCH1_PRTDSI__CAPS_SEL       (* (reg8 *) SWITCH1__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define SWITCH1_PRTDSI__DBL_SYNC_IN    (* (reg8 *) SWITCH1__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define SWITCH1_PRTDSI__OE_SEL0        (* (reg8 *) SWITCH1__PRTDSI__OE_SEL0) 
#define SWITCH1_PRTDSI__OE_SEL1        (* (reg8 *) SWITCH1__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define SWITCH1_PRTDSI__OUT_SEL0       (* (reg8 *) SWITCH1__PRTDSI__OUT_SEL0) 
#define SWITCH1_PRTDSI__OUT_SEL1       (* (reg8 *) SWITCH1__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define SWITCH1_PRTDSI__SYNC_OUT       (* (reg8 *) SWITCH1__PRTDSI__SYNC_OUT) 


#if defined(SWITCH1__INTSTAT)  /* Interrupt Registers */

    #define SWITCH1_INTSTAT                (* (reg8 *) SWITCH1__INTSTAT)
    #define SWITCH1_SNAP                   (* (reg8 *) SWITCH1__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins SWITCH1_H */


/* [] END OF FILE */
