/*******************************************************************************
* File Name: tx.h  
* Version 1.20
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2009, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_tx_H) /* Pins tx_H */
#define CY_PINS_tx_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "tx_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    tx_Write(uint8 value);
void    tx_SetDriveMode(uint8 mode);
uint8   tx_ReadDataReg(void);
uint8   tx_Read(void);
uint8   tx_ClearInterrupt(void);

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define tx_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define tx_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define tx_DM_RES_UP          PIN_DM_RES_UP
#define tx_DM_RES_DWN         PIN_DM_RES_DWN
#define tx_DM_OD_LO           PIN_DM_OD_LO
#define tx_DM_OD_HI           PIN_DM_OD_HI
#define tx_DM_STRONG          PIN_DM_STRONG
#define tx_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define tx_MASK               tx__MASK
#define tx_SHIFT              tx__SHIFT
#define tx_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define tx_PS                     (* (reg8 *) tx__PS)
/* Data Register */
#define tx_DR                     (* (reg8 *) tx__DR)
/* Port Number */
#define tx_PRT_NUM                (* (reg8 *) tx__PRT) 
/* Connect to Analog Globals */                                                  
#define tx_AG                     (* (reg8 *) tx__AG)                       
/* Analog MUX bux enable */
#define tx_AMUX                   (* (reg8 *) tx__AMUX) 
/* Bidirectional Enable */                                                        
#define tx_BIE                    (* (reg8 *) tx__BIE)
/* Bit-mask for Aliased Register Access */
#define tx_BIT_MASK               (* (reg8 *) tx__BIT_MASK)
/* Bypass Enable */
#define tx_BYP                    (* (reg8 *) tx__BYP)
/* Port wide control signals */                                                   
#define tx_CTL                    (* (reg8 *) tx__CTL)
/* Drive Modes */
#define tx_DM0                    (* (reg8 *) tx__DM0) 
#define tx_DM1                    (* (reg8 *) tx__DM1)
#define tx_DM2                    (* (reg8 *) tx__DM2) 
/* Input Buffer Disable Override */
#define tx_INP_DIS                (* (reg8 *) tx__INP_DIS)
/* LCD Common or Segment Drive */
#define tx_LCD_COM_SEG            (* (reg8 *) tx__LCD_COM_SEG)
/* Enable Segment LCD */
#define tx_LCD_EN                 (* (reg8 *) tx__LCD_EN)
/* Slew Rate Control */
#define tx_SLW                    (* (reg8 *) tx__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define tx_PRTDSI__CAPS_SEL       (* (reg8 *) tx__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define tx_PRTDSI__DBL_SYNC_IN    (* (reg8 *) tx__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define tx_PRTDSI__OE_SEL0        (* (reg8 *) tx__PRTDSI__OE_SEL0) 
#define tx_PRTDSI__OE_SEL1        (* (reg8 *) tx__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define tx_PRTDSI__OUT_SEL0       (* (reg8 *) tx__PRTDSI__OUT_SEL0) 
#define tx_PRTDSI__OUT_SEL1       (* (reg8 *) tx__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define tx_PRTDSI__SYNC_OUT       (* (reg8 *) tx__PRTDSI__SYNC_OUT) 


#if defined(tx__INTSTAT)  /* Interrupt Registers */

    #define tx_INTSTAT                (* (reg8 *) tx__INTSTAT)
    #define tx_SNAP                   (* (reg8 *) tx__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins tx_H */


/* [] END OF FILE */
