/*******************************************************************************
* File Name: rx.h  
* Version 1.20
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2009, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_rx_H) /* Pins rx_H */
#define CY_PINS_rx_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "rx_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    rx_Write(uint8 value);
void    rx_SetDriveMode(uint8 mode);
uint8   rx_ReadDataReg(void);
uint8   rx_Read(void);
uint8   rx_ClearInterrupt(void);

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define rx_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define rx_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define rx_DM_RES_UP          PIN_DM_RES_UP
#define rx_DM_RES_DWN         PIN_DM_RES_DWN
#define rx_DM_OD_LO           PIN_DM_OD_LO
#define rx_DM_OD_HI           PIN_DM_OD_HI
#define rx_DM_STRONG          PIN_DM_STRONG
#define rx_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define rx_MASK               rx__MASK
#define rx_SHIFT              rx__SHIFT
#define rx_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define rx_PS                     (* (reg8 *) rx__PS)
/* Data Register */
#define rx_DR                     (* (reg8 *) rx__DR)
/* Port Number */
#define rx_PRT_NUM                (* (reg8 *) rx__PRT) 
/* Connect to Analog Globals */                                                  
#define rx_AG                     (* (reg8 *) rx__AG)                       
/* Analog MUX bux enable */
#define rx_AMUX                   (* (reg8 *) rx__AMUX) 
/* Bidirectional Enable */                                                        
#define rx_BIE                    (* (reg8 *) rx__BIE)
/* Bit-mask for Aliased Register Access */
#define rx_BIT_MASK               (* (reg8 *) rx__BIT_MASK)
/* Bypass Enable */
#define rx_BYP                    (* (reg8 *) rx__BYP)
/* Port wide control signals */                                                   
#define rx_CTL                    (* (reg8 *) rx__CTL)
/* Drive Modes */
#define rx_DM0                    (* (reg8 *) rx__DM0) 
#define rx_DM1                    (* (reg8 *) rx__DM1)
#define rx_DM2                    (* (reg8 *) rx__DM2) 
/* Input Buffer Disable Override */
#define rx_INP_DIS                (* (reg8 *) rx__INP_DIS)
/* LCD Common or Segment Drive */
#define rx_LCD_COM_SEG            (* (reg8 *) rx__LCD_COM_SEG)
/* Enable Segment LCD */
#define rx_LCD_EN                 (* (reg8 *) rx__LCD_EN)
/* Slew Rate Control */
#define rx_SLW                    (* (reg8 *) rx__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define rx_PRTDSI__CAPS_SEL       (* (reg8 *) rx__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define rx_PRTDSI__DBL_SYNC_IN    (* (reg8 *) rx__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define rx_PRTDSI__OE_SEL0        (* (reg8 *) rx__PRTDSI__OE_SEL0) 
#define rx_PRTDSI__OE_SEL1        (* (reg8 *) rx__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define rx_PRTDSI__OUT_SEL0       (* (reg8 *) rx__PRTDSI__OUT_SEL0) 
#define rx_PRTDSI__OUT_SEL1       (* (reg8 *) rx__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define rx_PRTDSI__SYNC_OUT       (* (reg8 *) rx__PRTDSI__SYNC_OUT) 


#if defined(rx__INTSTAT)  /* Interrupt Registers */

    #define rx_INTSTAT                (* (reg8 *) rx__INTSTAT)
    #define rx_SNAP                   (* (reg8 *) rx__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins rx_H */


/* [] END OF FILE */
